;********************************************************************
;                       Ram Routines
;           - Move datas from IDE to RAM
;           - Fill RAM
;           - Calculate Source and Destination ram address  
;                                                                
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************

;**********************************************************
;        Ram (External Static Ram) 
;**********************************************************
FULL_BUFFER 
              clrf ADR_WL
              clrf ADR_WH 
FULL
              call RD_DATA_R       
              movf DATA_RL,w
              movwf BYTERAM
	      call WR_RAM

              incfsz ADR_WL
              goto TROLE
              incf ADR_WH
TROLE         
              movf DATA_RH,w
              movwf BYTERAM
	      call WR_RAM

;**********************
;**********************
              incfsz ADR_WL
              goto FORE
              incf ADR_WH
FORE     
              movf TOPE,w
              subwf ADR_WH,w
              btfss STATUS,Z
              goto FULL

              return
;**********************************************************
;********************************************************** 
FULL_BUFFERXX 
              clrf ADR_WL
              clrf ADR_WH 
              
FULL1
	      call WR_RAM

              incfsz ADR_WL
              goto TROLE1
              incf ADR_WH                   
;**********************
;**********************            
TROLE1
              movlw 0x80
              subwf ADR_WH,w
              btfss STATUS,Z
              goto FULL1
              movlw 0x00
              subwf ADR_WL,w
              btfss STATUS,Z
              goto FULL1 
              return
;**********************************************************
;**********************************************************
CAL_BASE       
              movf INDEX,w                  
              movwf TEMP1
              decf TEMP1
              clrf TEMP2
                 
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1,w
              rlf TEMP2

              movwf ADR_RL
              movf TEMP2,w
              addlw 0x40
              movwf ADR_RH

              movf ADR_RL,w
              movwf ADR_WL
              movf ADR_RH,w
              movwf ADR_WH
              return
          
CAL_DEST_DA
              movlw .4
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH                                 
              return           

CAL_DEST_CDROM
              movlw .9
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH                                 
              return                
;**********************************************************
;**********************************************************

