;********************************************************************
;                       Mp3 PuBliC
;                      MP3 CD Player
;
;                                                                
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************

               org RAM
PAGE1          equ 0x800
;**********************************************************
;    Miscl.
;**********************************************************        
         ; PORTA    a5  a4    a3    a2  a1  a0     
         ;         DEM  xx  Hab_Dec xx Sda Scl 
SCL           equ 0
SDA 	      equ 1
HAB_DEC       equ 3
DEM 	      equ 5
;**********************************************************
;   Ram32k
;          PORTE   e2 e1 e0
;                   0  0  0  RDn
;                   0  0  1  WRn         
;**********************************************************             
         ; PORTD   d7 d6 d5 d4 d3 d2 d1 d0 
         ;         D7 D6 D5 D4 D3 D2 D1 D0 

         ; PORTC   c7 c6 c5 c4 c3 c2 c1 c0
         ;         A7 A6 A5 A4 A3 A2 A1 A0

         ; PORTB   b7  b6  b5  b4  b3  b2 b1 b0
         ;        A15 A14 A13 A12 A11 A10 A9 A8  
         
READ_RAM      equ 0
WRITE_RAM     equ 1
;**********************************************************
;   Lcd 
;          PORTE   e2 e1 e0
;                   1  0  0  E_LCD
;**********************************************************
         ; PORTC   c7  c6  c5  c4  c3  c2  c1  c0
         ;         Db7 Db6 Db5 Db4 Db3 Db2 Db1 Db0
 
         ; PORTB   b7  b6  b5  b4  b3  b2  b1  b0
         ;         xx  xx  xx  xx  xx  xx RWn RSn   
E_LCD         equ 4
RSn           equ 0
RWn           equ 1  
;**********************************************************
;   Keys 
;**********************************************************
         ; PORTB   b7  b6  b5  b4   b3   b2   b1   b0
         ;         xx  xx  xx KEY5 KEY4 KEY3 KEY2 KEY1
         
         ; PORTA   a7 a6 a5 a4 a3   a2   a1 a0
         ;         xx xx xx xx xx Key_IN xx xx 
KEY1          equ 0
KEY2          equ 1
KEY3          equ 2
KEY4          equ 3
KEY5          equ 4
KEY_IN        equ 2
;**********************************************************
;   Stream 
;          PORTE   e2 e1 e0
;                   1  0  1  IIS_MAS
;**********************************************************
         ; PORTC   c7  c6 c5 c4 c3 c2 c1 c0
         ;        SID SIC xx xx xx xx xx xx
IIS_MAS       equ 5
SIC           equ 6
SID           equ 7
;**********************************************************
;   RESET Mas3507d and Dac3550a 
;          PORTE   e2 e1 e0
;                   1  1  0  RESET_MASDAC
;**********************************************************
RESET_MASDAC  equ 6
;**********************************************************
;   IDE
;          PORTE   e2 e1 e0
;                   0  1  0  RDn
;                   0  1  1  WRn
;**********************************************************
         ; PORTB  b7  b6  b5   b4   b3   b2  b1  b0
         ;        xx  xx  xx  Cs1n Cs0n Da2 Da1 Da0

         ; PORTC   c7  c6  c5  c4  c3  c2  c1  c0
         ;        DD7 DD6 DD5 DD4 DD3 DD2 DD1 DD0  

         ; PORTD   d7   d6   d5   d4   d3   d2   d1  d0 
         ;        DD15 DD14 DD13 DD12 DD11 DD10 DD9 DD8
READ_IDE      equ 2
WRITE_IDE     equ 3
D_STATUS      equ b'00010111'
D_STATUS_A    equ b'00001110'
D_COMMAND     equ D_STATUS
D_CILYNDER_H  equ b'00010101'
D_CILYNDER_L  equ b'00010100'
D_SECTOR_N    equ b'00010011'
D_SECTOR_C    equ b'00010010'
D_DEVICE_H    equ b'00010110'
D_FEATURES    equ b'00010001'
D_ERRORR      equ D_FEATURES
D_DATA_R      equ b'00010000'
D_DEVICE_C    equ D_STATUS_A
;**********************************************************
;**********************************************************  
         ; TASK REGISTERs ATA 
STATUS_R      res 1
STATUS_A      res 1
COMMAND       res 1
CILYNDER_H    res 1
CILYNDER_L    res 1
SECTOR_N      res 1
SECTOR_C      res 1
DEVICE_H      res 1
FEATURES      res 1
ERRORR        res 1
DEVICE_C      res 1
DATA_RL       res 1
DATA_RH       res 1
;**********************************************************
;**********************************************************
         ; FLAGs
FLAG_CD       res 1
         ; FLAG_CD  d7 d6 d5 d4  d3  d2  d1   d0
         ;          xx DA RO ST Pau Pre LoEj Start   
         ;                               0     0      Stop Disc
         ;                               0     1      Start Disc , read TOC
         ;                               1     0      Eject Disc 
	 ;                               1     1      Load Disc
         ;                           0   xx    xx     Allow Eject 
         ;                           1   xx    xx     Prevent Eject 
         ;                       0   xx  xx    xx     Pause
         ;                       1   xx  xx    xx     Resume
         ;                   0   xx  xx  xx    xx     Hay CD Cargado
         ;                   1   xx  xx  xx    xx     No hay CD Cargado
         ;             0  1  xx  xx  xx  xx    xx     CD-ROM
         ;             1  0  xx  xx  xx  xx    xx     CD-DA
         ;             1  1  xx  xx  xx  xx    xx     CD-HYBRID    
         ;
FLAG_KEY      res 1
         ; FLAG_KEY   d7 d6 d5  d4   d3  d2  d1   d0    
         ;            xx xx xx MODE STOP FRD REW PLAY
FLAG_KEY1     res 1
         ; FLAG_KEY1  d7 d6 d5  d4   d3  d2  d1   d0    
         ;            xx xx xx MODE STOP FRD REW PLAY

FLAG_STATE    res 1
         ; FLAG_STATE d7 d6   d5   d4    d3   d2  d1  d0                                                 
         ;                        MODE  EJECT    REW PAUSE                       
PLAY          equ 0
REW           equ 1
FRD           equ 2
STOP          equ 3
MODE          equ 4
PAUSE         equ 0
EJECT         equ 3
;**********************************************************
;**********************************************************
         ; VARIABLES y CONSTATES                     
             
         ; STATUS REGISTER
BSY           equ 7
DRDY          equ 6
DRQ           equ 3
ERR           equ 0
         ; ERROR REGISTER
ABRT          equ 2
         ; DEVICE CONTROL REGISTER
SRST          equ 2
nEIN          equ 1
         ; PKT COMMAND    
BP0           res 1
BP1           res 1
BP2           res 1
BP3           res 1
BP4           res 1
BP5           res 1
BP6           res 1
BP7           res 1
BP8           res 1
BP9           res 1
BP10          res 1
BP11          res 1

ADR_RL        res 1
ADR_RH        res 1
ADR_WL        res 1
ADR_WH        res 1
TOPE          res 1
BYTERAM       res 1
START_M       res 1
START_S       res 1
START_F       res 1
END_M         res 1
END_S         res 1
END_F         res 1
LBA_1         res 1
LBA_2         res 1
LBA_3         res 1
LBA_4         res 1
TRANS_1       res 1
TRANS_2       res 1
TRANS_3       res 1  
TRANS_4       res 1 
INDEX         res 1
INDEX_LIST    res 1
TOTAL_SONG    res 1
TOTAL_LIST    res 1
VOLUMEN       res 1
BASS          res 1
TREBLE        res 1
PRE           res 1
CONTROL       res 1

CONT1         res 1 
CONT2         res 1  
TEMPW         res 1
TEMP1         res 1
TEMP2         res 1
TEMP3         res 1
TEMP4         res 1
TEMP5         res 1
BASEF         res 4

ACC1	      res 1
ACC2          res 1 

FLAG          res 1
ATAPIn        equ 0
JOULIET       equ 1
ACK           equ 2
MANTIENE      equ 3
FINALMP3      equ 4
FINALMP31     equ 5
MARCA1        equ 6
MARCA2        equ 7
;**********************************************************
;**********************************************************
          ; LCD

REG_LCD       res 1
COUNTER       res 1
COUNTER1      res 1
MESSAJE       res 1
MESSAJE1      res 1
;**********************************************************
;**********************************************************
          ; BCD

COUNTER2      res 1
L_BYTE        res 1
DECENA        res 1 
MILENA        res 1
DIG_1         res 1
DIG_2         res 1
DIG_3         res 1
;**********************************************************
;**********************************************************
          ; I2C
BYTEIIC       res 1
BUFFERIIC     res 6
N_BYTEIIC     res 1
;**********************************************************
;**********************************************************
          ; Vectors 

              org 0
              goto START
;**********************************************************
;**********************************************************
          ; Macros

sdaup         MACRO
              bsf STATUS,RP0
              bsf TRISA,SDA
              bcf STATUS,RP0
              ENDM

sclup         MACRO
              bsf STATUS,RP0
              bsf TRISA,SCL
              bcf STATUS,RP0
              ENDM

sdadown       MACRO
              bsf STATUS,RP0
              bcf TRISA,SDA
              bcf STATUS,RP0
              ENDM

scldown       MACRO
              bsf STATUS,RP0
              bcf TRISA,SCL
              bcf STATUS,RP0
              ENDM
;**********************************************************
;**********************************************************
          ; Tablas 1 (Volumen, Bass, Treble, Prefactor tables)
BASE1         equ 0xE00
               
              org 0xE00
VOLUMEN_TABLE
               ; 0  1   2   3   4   5   6   7   8   9   10  11  12  13  14  15
              DT 0,.12,.20,.28,.32,.36,.38,.40,.42,.44,.46,.48,.50,.52,.54,.56 
BASS_TABLE
               ;     0         1         2         3         4         5
              DT 0x9e,0x40,0xa7,0x40,0xb1,0x80,0xbd,0x40,0xca,0x40,0xd8,0xc0
               ;     6         7      8      9        10        11
              DT 0xe8,0x00,0xf7,0xc0,0,0,0x00,0x80,0x17,0xc0,0x27,0x00
               ;    12        13        14        15        16
	      DT 0x35,0x80,0x42,0x80,0x4e,0x40,0x58,0x80,0x61,0x80                                     

TREBLE_TABLE
               ;     0         1         2         3         4         5
              DT 0xb2,0xc0,0xc1,0x80,0xcb,0xc0,0xd5,0x00,0xde,0x00,0xe7,0xe0             
               ;     6         7      8      9        10        11
              DT 0xf0,0xc0,0xfa,0xc0,0,0,0x05,0x40,0x10,0x40,0x1c,0x00 
               ;    12        13        14        15        16
              DT 0x28,0x40,0x35,0x40,0x42,0xc0,0x51,0x80,0x5f,0x80

PRE_TABLE
               ;     0         1         2         3         4         5
              DT 0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00
               ;     6         7         8         9        10        11
              DT 0x80,0x00,0x80,0x00,0x80,0x00,0x8e,0x00,0xa5,0x80,0xb8,0x00
               ;    12        13        14        15        16
              DT 0xc6,0xc0,0xd2,0x50,0xdc,0x00,0xe3,0x40,0xe9,0x40
;**********************************************************
;**********************************************************
          ; Tablas 2 (texts and Iso9660 mark)

BASE2         equ 0xF00
               
              org 0xF00
M_ID
              retlw 0x02
              DT "CD001"
M_TRACK
              DT "Track"       
M_NUM
              DT "0123456789"
M_0
              DT "   MP3 PuBliC   " ;1  
M_1
              DT " No CD Charged  " ;
M_2
              DT "     CD-Da      " ;2
M_3
              DT "     CD-Mp3     " ;3
M_4
              DT "   CD-Hybrid    " ;4
M_5
              DT "Tracks Found:   " ;5
M_6
              DT "    Volumen     " ;6
M_7
              DT "     Bass       " ;7  
M_8     
              DT "    Treble      " ;0 
M_9
              DT "                " ;1
M_10     
              DT "ATAPI Not Found " ;
M_11
              DT "   Door Open    " ;2          
;**********************************************************
;**********************************************************
              org ROM 
